import worker from './dispatcher-worker';

describe('The dispatcher-worker ', () => {
  let port;
  beforeEach(() => {
    port = {
      postMessage: jest.fn(),
    };
    worker.onconnect({ ports: [port] });
  });
  test('creates a onmessage function', () => {
    expect(port.onmessage).toBeDefined();
    expect(port.postMessage).not.toBeCalled();
  });
  test('receives a ping and sends a pong', () => {
    port.onmessage({ data: { id: 5, payload: 'ping' } });
    expect(port.postMessage).toBeCalledWith({ id: 5, payload: '"ping" pong' });
  });
});
